Debian Bug report logs - #458144
libxml-parser-perl: depends/build depends loop makes building against new perl versions impossible

version graph

Package: libxml-parser-perl; Maintainer for libxml-parser-perl is Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>; Source for libxml-parser-perl is src:libxml-parser-perl.

Reported by: peter green <plugwash@p10link.net>

Date: Sat, 29 Dec 2007 00:45:02 UTC

Severity: important

Tags: patch

Found in version libxml-parser-perl_2.34-4.3

Fixed in version libxml-parser-perl/2.36-1.1

Done: Niko Tyni <ntyni@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to peter green <plugwash@p10link.net>:
New Bug report received and forwarded. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: peter green <plugwash@p10link.net>
To: submit@bugs.debian.org
Subject: libxml-parser-perl: depends/build depends loop makes building against new perl versions impossible
Date: Sat, 29 Dec 2007 00:21:11 +0000
package: libxml-parser-perl
version: libxml-parser-perl_2.34-4.3
severity: important

I was trying to rebuild your package against the version of perl in 
experimental.

While doing this I discovered that libxml-parser-perl build-depends on 
libxml-encoding-perl which in turn depends on libxml-parser-perl. Since 
two versions of libperl can't be installed at the same time on debian 
this makes it impossible to build libxml-parser-perl against a new major 
version of perl.






Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to peter green <plugwash@p10link.net>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 458144@bugs.debian.org (full text, mbox):

From: peter green <plugwash@p10link.net>
To: 458144@bugs.debian.org
Subject: re: libxml-parser-perl: depends/build depends loop makes building against, new perl versions impossible
Date: Tue, 01 Jan 2008 22:11:31 +0000
Well I took another look at this bug and it looks like the build-dep 
issue was introduced with the previous NMU so I went back to the 
previous version but then ran into another problem with the testsuite 
failing.

t/encoding........"my" variable $p masks earlier declaration in same 
scope at t/encoding.t line 94.
t/encoding........FAILED test 
3                                                     Failed 1/6 tests, 
83.33% okay

I disabled the testsuite and that version built.

I then used that version to satisfy the depencies of the latest version 
but that then failed to build with

Not a HASH reference at /usr/bin/compile_encoding line 42.

repeated quite a number of times.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Ardo van Rangelrooij <ardo@ardolabs.com>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #15 received at 458144@bugs.debian.org (full text, mbox):

From: Ardo van Rangelrooij <ardo@ardolabs.com>
To: peter green <plugwash@p10link.net>, 458144@bugs.debian.org
Subject: Re: [xml/sgml-pkgs] Bug#458144: libxml-parser-perl: depends/build depends loop makes building against, new perl versions impossible
Date: Tue, 01 Jan 2008 16:23:17 -0600
peter green wrote:
> Well I took another look at this bug and it looks like the build-dep 
> issue was introduced with the previous NMU so I went back to the 
> previous version but then ran into another problem with the testsuite 
> failing.
> 
> t/encoding........"my" variable $p masks earlier declaration in same 
> scope at t/encoding.t line 94.
> t/encoding........FAILED test 
> 3                                                     Failed 1/6 tests, 
> 83.33% okay
> 
> I disabled the testsuite and that version built.
> 
> I then used that version to satisfy the depencies of the latest version 
> but that then failed to build with
> 
> Not a HASH reference at /usr/bin/compile_encoding line 42.
> 
> repeated quite a number of times.

This has just been reported in 458578.

Thanks,
Ardo
-- 
Ardo van Rangelrooij                                     Debian XML/SGML Group
<ardo@debian.org>              <debian-xml-sgml-devel@lists.alioth.debian.org>
http://people.debian.org/~ardo/      http://debian-xml-sgml.alioth.debian.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #20 received at 458144@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: 458144@bugs.debian.org
Subject: FWD: Re: libxml-parser-perl: depends/build depends loop makes building against, new perl versions impossible
Date: Mon, 21 Jan 2008 17:06:09 -0500
[Message part 1 (text/plain, inline)]
Resend since I typoed the address the first time.

----- Forwarded message from Joey Hess <joeyh@debian.org> -----

From: Joey Hess <joeyh@debian.org>
Date: Tue, 1 Jan 2008 15:15:34 -0500
To: peter green <plugwash@p10link.net>
Cc: 458144@bugs.debian.oet
Subject: Re: libxml-parser-perl: depends/build depends loop makes building
	against, new perl versions impossible
User-Agent: Mutt/1.5.17 (2007-11-01)

In #132989 I described four ways to fix that bug, and ended up using
the first of them, since the maintainer made the mecessary changes to
libxml-encoding-perl to allow it, and since that was more NMU-amenable
solution to the bug than adding a bunch of uuencoded encoding files to
libxml-parser-perl.

To avoid the build dependency loop, any of the other three solutions
could be used. Note that #132989 includes an old patch implementing the
fourth option, if you're looking for a quick fix. I'm not sure if that
patch includes all the encoding files, so it might need to be updated.

> Well I took another look at this bug and it looks like the build-dep issue 
> was introduced with the previous NMU so I went back to the previous version 
> but then ran into another problem with the testsuite failing.
>
> t/encoding........"my" variable $p masks earlier declaration in same scope 
> at t/encoding.t line 94.
> t/encoding........FAILED test 3                                             
>         Failed 1/6 tests, 83.33% okay
>
> I disabled the testsuite and that version built.

FWIW, that testsuite failure seems to be caused by the new perl somehow.
(And it's not related to the "my" warning.)

Rather than using an old version, you can use the current version, just
change the debian/rules temporarily to not run compile_encoding, and
ignore the build dependency.

> I then used that version to satisfy the depencies of the latest version but 
> that then failed to build with
>
> Not a HASH reference at /usr/bin/compile_encoding line 42.
>
> repeated quite a number of times.

Yugh! libxml-encoding-perl's compile_encoding uses a pseudo hash, so
that will need to be fixed before it will work with perl 5.10.

I've filed a separate bug about that, but I don't have a fix handy yet.

-- 
see shy jo



----- End forwarded message -----
-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #25 received at 458144@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 458144@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>
Subject: Re: Bug#458144: libxml-parser-perl: depends/build depends loop makes building against, new perl versions impossible
Date: Fri, 22 Feb 2008 21:31:54 +0200
[Message part 1 (text/plain, inline)]
On Mon, Jan 21, 2008 at 05:06:09PM -0500, Joey Hess wrote:

> In #132989 I described four ways to fix that bug, and ended up using
> the first of them, since the maintainer made the mecessary changes to
> libxml-encoding-perl to allow it, and since that was more NMU-amenable
> solution to the bug than adding a bunch of uuencoded encoding files to
> libxml-parser-perl.
> 
> To avoid the build dependency loop, any of the other three solutions
> could be used. Note that #132989 includes an old patch implementing the
> fourth option, if you're looking for a quick fix. I'm not sure if that
> patch includes all the encoding files, so it might need to be updated.

Time is running out: libxml-parser-perl will be uninstallable and
unbuildable (taking along a bunch of other packages) in a week or so
unless this is fixed. See

 http://lists.debian.org/debian-perl/2008/02/msg00093.html

I came up with one more possible solution: as the encoding maps are
architecture independent, they could be split out into a separate package
so that libxml-encoding-perl isn't needed for binNMUs at all.

Proposed patch attached; this seems to work for me. It's not a solution
suitable for an NMU, so I would appreciate comments from the package
maintainers.

The patch puts the encodings in /usr/share/libxml-parser-perl and symlinks
/usr/share/perl5/XML/Parser/Encodings there. XML::Parser looks for the
encoding files in the whole @INC, so moving them from /usr/lib/perl5
isn't a problem.

Cheers,
-- 
Niko Tyni   ntyni@debian.org
[458144.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Ardo van Rangelrooij <ardo@ardolabs.com>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #30 received at 458144@bugs.debian.org (full text, mbox):

From: Ardo van Rangelrooij <ardo@ardolabs.com>
To: Niko Tyni <ntyni@debian.org>, 458144@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>
Subject: Re: [xml/sgml-pkgs] Bug#458144: libxml-parser-perl: depends/build depends loop makes building against, new perl versions impossible
Date: Sun, 24 Feb 2008 20:41:13 -0600
Niko Tyni wrote:
> On Mon, Jan 21, 2008 at 05:06:09PM -0500, Joey Hess wrote:
> 
>> In #132989 I described four ways to fix that bug, and ended up using
>> the first of them, since the maintainer made the mecessary changes to
>> libxml-encoding-perl to allow it, and since that was more NMU-amenable
>> solution to the bug than adding a bunch of uuencoded encoding files to
>> libxml-parser-perl.
>>
>> To avoid the build dependency loop, any of the other three solutions
>> could be used. Note that #132989 includes an old patch implementing the
>> fourth option, if you're looking for a quick fix. I'm not sure if that
>> patch includes all the encoding files, so it might need to be updated.
> 
> Time is running out: libxml-parser-perl will be uninstallable and
> unbuildable (taking along a bunch of other packages) in a week or so
> unless this is fixed. See
> 
>  http://lists.debian.org/debian-perl/2008/02/msg00093.html
> 
> I came up with one more possible solution: as the encoding maps are
> architecture independent, they could be split out into a separate package
> so that libxml-encoding-perl isn't needed for binNMUs at all.
> 
> Proposed patch attached; this seems to work for me. It's not a solution
> suitable for an NMU, so I would appreciate comments from the package
> maintainers.
> 
> The patch puts the encodings in /usr/share/libxml-parser-perl and symlinks
> /usr/share/perl5/XML/Parser/Encodings there. XML::Parser looks for the
> encoding files in the whole @INC, so moving them from /usr/lib/perl5
> isn't a problem.
> 
> Cheers,

Hi,

I think it is better if for the time being we simply break the dependency.
I'll add the generated encoding files to libxml-parser-perl and remove the
build dependency on libxml-encoding-perl.  This is suboptimal but keeps us
going.  I'll leave 458144 open and work on a permanent bootstrap solution.

Thanks,
Ardo
-- 
Ardo van Rangelrooij                                     Debian XML/SGML Group
<ardo@debian.org>              <debian-xml-sgml-devel@lists.alioth.debian.org>
http://people.debian.org/~ardo/      http://debian-xml-sgml.alioth.debian.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #35 received at 458144@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: debian-release@lists.debian.org
Cc: 465783@bugs.debian.org, 458144@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Tue, 25 Mar 2008 20:14:55 +0200
On Tue, Mar 25, 2008 at 06:37:11PM +0100, Marc 'HE' Brockschmidt wrote:

> http://ftp-master.debian.org/~he/perl-NMUs is a list of packages
> depending on '(perlapi-5.8|libperl5.8)'. We will need to schedule about
> ~295 binNMUs for perl5.10, for such small packages such as abiword,
> postgres-* and most of our mail servers. This will put *massive* load on
> the build machines.

Hi,

repeating notes from along the way to make sure you're aware of these
issues. They are collected at <http://wiki.debian.org/Perl5.10Transition>.

- there are five more packages needing a binNMU, they are missing ${perl:Depends}
  http://lintian.debian.org/reports/tags/missing-dependency-on-perlapi.html
  Bugs have been filed, and I believe lasso was fixed today.

- the packages needing binNMUs depend on each other for building. I cooked 
  up a rebuild order for the binNMUs back in January, see
  http://lists.debian.org/debian-perl/2008/01/msg00218.html

- it would be great if the build dependency loop with libxml-parser-perl 
  (#458144, Cc'd) could be fixed first. I think it's by far the most 
  significant problem for the binNMUs.

- I don't really know how the perl on the buildds is going to be updated, but
  manual intervention may be required to favour debconf-english over
  debconf-i18n so as to keep the Essential:yes packages installed. See
  http://lists.debian.org/debian-perl/2008/01/msg00220.html

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Marc 'HE' Brockschmidt <he@ftwca.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #40 received at 458144@bugs.debian.org (full text, mbox):

From: Marc 'HE' Brockschmidt <he@ftwca.de>
To: debian-release@lists.debian.org
Cc: 465783@bugs.debian.org, 458144@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Wed, 26 Mar 2008 00:04:50 +0100
[Message part 1 (text/plain, inline)]
Niko Tyni <ntyni@debian.org> writes:
> On Tue, Mar 25, 2008 at 06:37:11PM +0100, Marc 'HE' Brockschmidt wrote:
>> http://ftp-master.debian.org/~he/perl-NMUs is a list of packages
>> depending on '(perlapi-5.8|libperl5.8)'. We will need to schedule about
>> ~295 binNMUs for perl5.10, for such small packages such as abiword,
>> postgres-* and most of our mail servers. This will put *massive* load on
>> the build machines.
> repeating notes from along the way to make sure you're aware of these
> issues. They are collected at <http://wiki.debian.org/Perl5.10Transition>.

Thanks, but I already use the wiki page as starting point (noone can
expect me to actually remember the BTS URIs for the usertagged reports,
right?)

The problem right now is that the situation wrt testing migration isn't
too rosy anyway at the moment, seeing how we are blocked by ghc6,
openexr/kdelibs, suitespare/openoffice.org (which is now in turn stuck
ehin kdelibs) and some other transitions. The moment perl5.10 has been
uploaded to unstable, we will need to basically freeze unstable for a
few days to get it through to testing without entangling it with other
transitions.

Brendan, have you already planned a perl upload to unstable?

> - it would be great if the build dependency loop with libxml-parser-perl 
>   (#458144, Cc'd) could be fixed first. I think it's by far the most 
>   significant problem for the binNMUs.

Yes. Ardo, could you update libxml-parser-perl with the workaround
proposed in <47C22AC9.1050300@ardolabs.com>?

Marc
-- 
Fachbegriffe der Informatik - Einfach erklärt
185: LaTeX
       Eine spĂĽlmaschinenfeste Seitenbeschreibungssprache. (Cornell Binder)
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#458144; Package libxml-parser-perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #45 received at 458144@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 458144@bugs.debian.org
Subject: libxml-parser-perl: diff for (delayed) NMU version 2.36-1.1
Date: Thu, 3 Apr 2008 22:11:04 +0300
[Message part 1 (text/plain, inline)]
tags 458144 + patch pending
thanks

Hi Ardo,

Perl 5.10.0 is scheduled for unstable on 20080416, and this should
definitely be fixed before that.

Given your silence, I just uploaded an NMU in 7-day DELAYED implementing
your preferred option of including the generated encoding files in the
source package. Diff attached.

Feel free to cancel or override the upload, as long as the bug gets fixed.

Cheers,
-- 
Niko Tyni   ntyni@debian.org
[libxml-parser-perl-2.36-1.1-nmu.diff (text/x-diff, attachment)]

Tags added: patch, pending Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Thu, 03 Apr 2008 19:12:15 GMT) Full text and rfc822 format available.

Reply sent to Niko Tyni <ntyni@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to peter green <plugwash@p10link.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #52 received at 458144-close@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 458144-close@bugs.debian.org
Subject: Bug#458144: fixed in libxml-parser-perl 2.36-1.1
Date: Wed, 09 Apr 2008 21:17:25 +0000
Source: libxml-parser-perl
Source-Version: 2.36-1.1

We believe that the bug you reported is fixed in the latest version of
libxml-parser-perl, which is due to be installed in the Debian FTP archive:

libxml-parser-perl_2.36-1.1.diff.gz
  to pool/main/libx/libxml-parser-perl/libxml-parser-perl_2.36-1.1.diff.gz
libxml-parser-perl_2.36-1.1.dsc
  to pool/main/libx/libxml-parser-perl/libxml-parser-perl_2.36-1.1.dsc
libxml-parser-perl_2.36-1.1_amd64.deb
  to pool/main/libx/libxml-parser-perl/libxml-parser-perl_2.36-1.1_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 458144@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Niko Tyni <ntyni@debian.org> (supplier of updated libxml-parser-perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Thu, 03 Apr 2008 21:31:59 +0300
Source: libxml-parser-perl
Binary: libxml-parser-perl
Architecture: source amd64
Version: 2.36-1.1
Distribution: unstable
Urgency: low
Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Changed-By: Niko Tyni <ntyni@debian.org>
Description: 
 libxml-parser-perl - Perl module for parsing XML files
Closes: 458144
Changes: 
 libxml-parser-perl (2.36-1.1) unstable; urgency=low
 .
   * Non-maintainer upload for the Perl 5.10 transition.
   * Copy and uuencode the additional generated encoding files from the
     previous version of this package instead of build-depending on
     libxml-encoding-perl to break a dependency loop. (Closes: #458144)
Files: 
 29aa542d941e4464cc0eda95ca3eee6d 1015 perl optional libxml-parser-perl_2.36-1.1.dsc
 8f2059b56a498579ac1481ad275a5a52 8312 perl optional libxml-parser-perl_2.36-1.1.diff.gz
 aa48868d7e5e3b4ccb2eaeac99f359c9 295594 perl optional libxml-parser-perl_2.36-1.1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFH9SndiyizGWoHLTkRAjljAJ9pKFcbaJv6WHvlg/5AKrWm6wGAGgCeIPaQ
ZkWKBWXX80w56usADLhKXlM=
=Wnpl
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 08 May 2008 07:31:24 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 20:14:44 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.